#include <bits/stdc++.h>
using namespace std;
#define mod 998244353
int  main(){
int n,m;
cin >>n>>m;
vector <int> b(m+1);
vector <int> a(n+1);
for(int i=1;i<=n;i++)a[i]=i;
for(int i=1;i<=m;i++)cin >>b[i];
for(int i=0;i<=n-m;i++){
for(int j=1;j<=m;j++){
a[i+b[j]]=a[i+j];
}
}
int c;
cin >>c;
long long rez=0;
long long step=c;
for(int i=1;i<=n;i++){
rez+=step*a[i];
rez%=mod;
step*=c;
step%=mod;

}
/*for(int i=1;i<=n;i++){
    cout <<a[i]<<" ";
}cout<<endl;*/
cout <<rez%mod<<endl;
}